package com.bizmatics.mhfire.controller.web.bulehelp;


import com.bizmatics.common.core.bean.ApiResult;
import com.bizmatics.common.core.bean.CommonPage;
import com.bizmatics.mhfire.model.bulehelp.RobotQuestionKey;
import com.bizmatics.mhfire.model.bulehelp.RobotQuestionMessage;
import com.bizmatics.mhfire.service.bulehelp.RobotQuestionMessageService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * <p>
 *  搜索问题记录表
 * </p>
 *
 * @author yq
 * @since 2021-06-15
 */
@RestController
@RequestMapping("/bule/robotQuestionMessage")
public class RobotQuestionMessageController {

    @Autowired
    private RobotQuestionMessageService robotQuestionMessageService;


    /**
     * 分页
     * @param current 页数
     * @param size 条数
     * @param classIf  分类
     * @return
     */
    @GetMapping("/page")
    public ApiResult<CommonPage<RobotQuestionMessage>> page(@RequestParam Integer current,
                                                        @RequestParam Integer size,
                                                        @RequestParam(required = false) String classIf){
        return ApiResult.success(robotQuestionMessageService.page(current, size, classIf));
    }
}

